﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;

namespace Calculator
{
    public class Calculate : INotifyPropertyChanged
    {
        private double? firstCount;
        private double? secondCount;
        private object result;

        public double? FirstCount { get => firstCount; set => firstCount = value; }
        public double? SecondCount { get => secondCount; set => secondCount = value; }
        public object Result
        {
            get => result; set
            {
                result = value;
                PropertyChanged.Invoke(this, new PropertyChangedEventArgs(nameof(Result)));
            }
        }

        /// <summary>
        /// Определение типа оператора.
        /// </summary>
        public bool BinaryOperator { get; set; } = false;


        public event PropertyChangedEventHandler PropertyChanged;

        public ICommand Sum
        {
            get
            {
                return new DelegateCommand(obj =>
                {
                    Result = FirstCount + SecondCount;
                });
            }
        }
        public ICommand Difr
        {
            get
            {
                return new DelegateCommand(obj =>
                {
                    Result = FirstCount - SecondCount;
                });
            }
        }
        public ICommand Multiplication
        {
            get
            {
                return new DelegateCommand(obj =>
                {
                    Result = FirstCount * SecondCount;
                });
            }
        }
        public ICommand Division
        {
            get
            {
                return new DelegateCommand(obj =>
                {
                    try
                    {
                        Result = FirstCount / SecondCount;
                    }
                    catch (Exception)
                    {
                        Result = "Ошибка!";
                    }
                    
                });
            }
        }
        public ICommand sin
        {
            get
            {
                return new DelegateCommand(obj =>
                {
                    Result = FirstCount / SecondCount;
                });
            }
        }


        

    }
}
